// swiftdatabasebase.hpp
//
// Copyright (c) 2004-2006, Kim Roland Rasmussen <krr@elreki.net>
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation files
// (the "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the 
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// 

#ifndef _SWIFT_SWIFTDATABASEBASE_
#define _SWIFT_SWIFTDATABASEBASE_

#include <boost/cstdint.hpp>
#include <ctime>
#include <string>
#include <vector>

namespace swift {

// SwiftDatabaseBase class declaration --------------------------------------

class SwiftDatabaseBase
{
    public:
    typedef boost::uint32_t uint32;
    typedef boost::uint32_t Offset;
    typedef std::vector<Offset> OffsetVector;

    struct IndexHeader
    {
        IndexHeader() : tag(0x54465753) { } // "SWFT"
        uint32 tag;
        uint32 sequenceCount;
        time_t constructionDate;
    };

    static char const * IndexSuffix;
    static char const * TextSuffix;
    static char const * SequenceSuffix;

    protected:
    SwiftDatabaseBase();
};

// --------------------------------------------------------------------------

} // namespace swift


#endif

