// createcommand.hpp
//
// Copyright (c) 2004-2006, Kim Roland Rasmussen <krr@elreki.net>
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation files
// (the "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//
//
// Additions / changes by Peter Husemann
//

#ifndef _SWIFT_CREATECOMMAND_
#define _SWIFT_CREATECOMMAND_

#include "swiftcommand.hpp"
#include <boost/program_options.hpp>
#include <iostream>
#include <string>
#include <vector>

namespace swift
{


class CreateCommand : public SwiftCommand
{
    public:
    CreateCommand();
    virtual void execute(int argc, char ** argv);
    virtual void displayUsage(std::ostream & outStream = std::cout) const;

    private:
    bool processArguments(int argc, char ** argv);
    void createDatabase();
    std::string extractId(std::string const & defline) const;

    boost::program_options::options_description visibleOptions_;
    boost::program_options::options_description hiddenOptions_;

    std::string databasePrefix_;
    typedef std::vector<std::string> NamesVector;
    NamesVector inputFiles_;
};


} // namespace swift

#endif
